#ifndef QCDNUMfw_H
#define QCDNUMfw_H

// Declarations for the Fortran/C interface
#include "QCDNUM/FortranWrappers.h"

extern "C" {


  /**************************************************************/
  /*  MBUTIL hash routines from hash.f                          */
  /**************************************************************/

  #define fimb_ihash FC_FUNC(imb_ihash,IMB_IHASH)
    int fimb_ihash(int*, int*, int*);
  #define fimb_jhash FC_FUNC(imb_jhash,IMB_JHASH)
    int fimb_jhash(int*, double*, int*);
  #define fimb_dhash FC_FUNC(imb_dhash,IMB_DHASH)
    int fimb_dhash(int*, double*, int*);

  /**************************************************************/
  /*  MBUTIL character routines from mchar.f                    */
  /**************************************************************/

  #define fsmb_hcodecpp FC_FUNC(smb_hcodecpp,SMB_HCODECPP)
    void fsmb_hcodecpp(int*, char*, int*);

  /**************************************************************/
  /*  MBUTIL workspace routines from wspace.f                   */
  /**************************************************************/

  #define fimb_wsinit FC_FUNC(imb_wsinit,IMB_WSINIT)
    int fimb_wsinit(double*, int*, int*);
  #define fsmb_setwsn FC_FUNC(smb_setwsn,SMB_SETWSN)
    void fsmb_setwsn(double*, int*);
  #define fimb_newset FC_FUNC(imb_newset,IMB_NEWSET)
    int fimb_newset(double*);
  #define fimb_wtable FC_FUNC(imb_wtable,IMB_WTABLE)
    int fimb_wtable(double*, int*, int*, int*);
  #define fimb_wclone FC_FUNC(imb_wclone,IMB_WCLONE)
    int fimb_wclone(double*, int*, double*);
  #define fsmb_tbcopy FC_FUNC(smb_tbcopy,SMB_TBCOPY)
    void fsmb_tbcopy(double*, int*, double*, int*, int*);
  #define fsmb_tsdumpcpp FC_FUNC(smb_tsdumpcpp,SMB_TSDUMPCPP)
    void fsmb_tsdumpcpp(char*, int*, int*, double*, int*, int*);
  #define fimb_tsreadcpp FC_FUNC(imb_tsreadcpp,IMB_TSREADCPP)
    int fimb_tsreadcpp(char*, int*, int*, double*, int*);
  #define fimb_markercpp FC_FUNC(imb_markercpp,IMB_MARKERCPP)
    int fimb_markercpp(char*,int*);
  #define fimb_hdsize FC_FUNC(imb_hdsize,IMB_HDSIZE)
    int fimb_hdsize();
  #define fimb_tbsize FC_FUNC(imb_tbsize,IMB_TBSIZE)
    int fimb_tbsize(int*, int*, int*);
  #define fimb_tpoint FC_FUNC(imb_tpoint,IMB_TPOINT)
    int fimb_tpoint(double*, int*, int*, int*);

  #define fimb_isaworkspace FC_FUNC(imb_isaworkspace,IMB_ISAWORKSPACE)
    int fimb_isaworkspace(double*);
  #define fimb_sizeofw FC_FUNC(imb_sizeofw,IMB_SIZEOFW)
    int fimb_sizeofw(double*);
  #define fimb_wordsused FC_FUNC(imb_wordsused,IMB_WORDSUSED)
    int fimb_wordsused(double*);
  #define fimb_nheader FC_FUNC(imb_nheader,IMB_NHEADER)
    int fimb_nheader(double*);
  #define fimb_ntags FC_FUNC(imb_ntags,IMB_NTAGS)
    int fimb_ntags(double*);
  #define fimb_headskip FC_FUNC(imb_headskip,IMB_HEADSKIP)
    int fimb_headskip(double*);
  #define fimb_iadrain FC_FUNC(imb_iadrain,IMB_IADRAIN)
    int fimb_iadrain(double*);
  #define fimb_ianull FC_FUNC(imb_ianull,IMB_IANULL)
    int fimb_ianull(double*);
  #define fimb_objecttype FC_FUNC(imb_objecttype,IMB_OBJECTTYPE)
    int fimb_objecttype(double*, int*);
  #define fimb_objectsize FC_FUNC(imb_objectsize,IMB_OBJECTSIZE)
    int fimb_objectsize(double*, int*);
  #define fimb_nobjects FC_FUNC(imb_nobjects,IMB_NOBJECTS)
    int fimb_nobjects(double*, int*);
  #define fimb_objectnumber FC_FUNC(imb_objectnumber,IMB_OBJECTNUMBER)
    int fimb_objectnumber(double*, int*);
  #define fimb_fingerprint FC_FUNC(imb_fingerprint,IMB_FINGERPRINT)
    int fimb_fingerprint(double*, int*);
  #define fimb_iafirsttag FC_FUNC(imb_iafirsttag,IMB_IAFIRSTTAG)
    int fimb_iafirsttag(double*, int*);
  #define fimb_tabledim FC_FUNC(imb_tabledim,IMB_TABLEDIM)
    int fimb_tabledim(double*, int*);
  #define fimb_iakarray FC_FUNC(imb_iakarray,IMB_IAKARRAY)
    int fimb_iakarray(double*, int*);
  #define fimb_iaimin FC_FUNC(imb_iaimin ,IMB_IAIMIN)
    int fimb_iaimin(double*, int*);
  #define fimb_iaimax FC_FUNC(imb_iaimax ,IMB_IAIMAX)
    int fimb_iaimax(double*, int*);
  #define fimb_begintbody FC_FUNC(imb_begintbody ,IMB_BEGINTBODY)
    int fimb_begintbody(double*, int*);
  #define fimb_endtbody FC_FUNC(imb_endtbody ,IMB_ENDTBODY)
    int fimb_endtbody(double*, int*);
  #define fimb_dchdir FC_FUNC(imb_dchdir ,IMB_DCHDIR)
    int fimb_dchdir(double*, int*);
  #define fimb_dfskip FC_FUNC(imb_dfskip ,IMB_DFSKIP)
    int fimb_dfskip(double*, int*);
  #define fimb_dbskip FC_FUNC(imb_dbskip ,IMB_DBSKIP)
    int fimb_dbskip(double*, int*);
  #define fsmbwstree FC_FUNC(smbwstree ,SMBWSTREE)
    int fsmbwstree(double*, int*);
  #define fsmb_wshead FC_FUNC(smb_wshead ,SMB_WSHEAD)
    int fsmb_wshead(double*, int*);

  /**************************************************************/
  /*  TOOLBOX init routines from tbx00ini.f                     */
  /**************************************************************/

  #define ftbx_wsinit FC_FUNC(tbx_wsinit,TBX_WSINIT)
    void ftbx_wsinit(double*, int*);

  /**************************************************************/
  /*  TOOLBOX pointer routines from tbxpointers.f               */
  /**************************************************************/


  /**************************************************************/
  /*  TOOLBOX workspace routines from tbxwspace.f               */
  /**************************************************************/


  /**************************************************************/
  /*  QCDNUM evolution routines from usrevol.f                  */
  /**************************************************************/

  #define frfromf FC_FUNC(rfromf,RFROMF)
    double frfromf(double*);
  #define fffromr FC_FUNC(ffromr,FFROMR)
    double fffromr(double*);
  #define fasfunc FC_FUNC(asfunc,ASFUNC)
    double fasfunc(double*, int*, int*);
  #define faltabn FC_FUNC(altabn,ALTABN)
    double faltabn(int*, int*, int*, int*);
  #define fevolfg FC_FUNC(evolfg,EVOLFG)
    void fevolfg(int*, double (*)(int* ,double*), double*, int*, double*);
  #define fevsgns FC_FUNC(evsgns,EVSGNS)
    void fevsgns(int*, double (*)(int* ,double*), int*, int*, int*, double*);
  #define fpdfcpy FC_FUNC(pdfcpy,PDFCPY)
    void fpdfcpy(int*, int*);
  #define fextpdf FC_FUNC(extpdf,EXTPDF)
    void fextpdf(double (*)(int*, double* ,double* ,bool*), int*, int*, double*, double*);
  #define fusrpdf FC_FUNC(usrpdf,USRPDF)
    void fusrpdf(double (*)(int*, double* ,double* ,bool*), int*, int*, double*, double*);
  #define fnptabs FC_FUNC(nptabs,NPTABS)
    int fnptabs(int*);
  #define fievtyp FC_FUNC(ievtyp,IEVTYP)
    int fievtyp(int*);

  /**************************************************************/
  /*  QCDNUM grid routines from usrgrd.f                        */
  /**************************************************************/

  #define fgxmake FC_FUNC(gxmake,GXMAKE)
    void fgxmake(double*, int*, int*, int*, int*, int*);
  #define fixfrmx FC_FUNC(ixfrmx,IXFRMX)
    int fixfrmx(double*);
  #define fxxatix FC_FUNC(xxatix,XXATIX)
    int fxxatix(double*, int*);
  #define fxfrmix FC_FUNC(xfrmix,XFRMIX)
    double fxfrmix(int*);
  #define fgxcopy FC_FUNC(gxcopy,GXCOPY)
    void fgxcopy(double*, int*, int*);
  #define fgqmake FC_FUNC(gqmake,GQMAKE)
    void fgqmake(double*, double*, int*, int*, int*);
  #define fiqfrmq FC_FUNC(iqfrmq,IQFRMQ)
    int fiqfrmq(double*);
  #define fqqatiq FC_FUNC(qqatiq,QQATIQ)
    int fqqatiq(double*, int*);
  #define fqfrmiq FC_FUNC(qfrmiq,QFRMIQ)
    double fqfrmiq(int*);
  #define fgqcopy FC_FUNC(gqcopy,GQCOPY)
    void fgqcopy(double*, int*, int*);
  #define fgrpars FC_FUNC(grpars,GRPARS)
    void fgrpars(int*, double*, double*, int*, double*, double*, int*);
  #define fsetlim FC_FUNC(setlim,SETLIM)
    void fsetlim(int*, int*, int*, double*);
  #define fgetlim FC_FUNC(getlim,GETLIM)
    void fgetlim(int*, double*, double*, double*, double*);

  /**************************************************************/
  /*  QCDNUM init routines from usrini.f                        */
  /**************************************************************/

  #define fqcinitcpp FC_FUNC(qcinitcpp,QCINITCPP)
    void fqcinitcpp(int*, char*, int*);
  #define fsetluncpp FC_FUNC(setluncpp,SETLUNCPP)
    void fsetluncpp(int*, char*, int*);
  #define fnxtlun FC_FUNC(nxtlun,NXTLUN)
    int fnxtlun(int*);
  #define fsetvalcpp FC_FUNC(setvalcpp,SETVALCPP)
    void fsetvalcpp(char*, int*, double*);
  #define fgetvalcpp FC_FUNC(getvalcpp,GETVALCPP)
    void fgetvalcpp(char*, int*, double*);
  #define fsetintcpp FC_FUNC(setintcpp,SETINTCPP)
    void fsetintcpp(char*, int*, int*);
  #define fgetintcpp FC_FUNC(getintcpp,GETINTCPP)
    void fgetintcpp(char*, int*, int*);
  #define fqstorecpp FC_FUNC(qstorecpp,QSTORECPP)
    void fqstorecpp(char*, int*, int*, double*);

  /**************************************************************/
  /*  QCDNUM parameter routines from usrparams.f                */
  /**************************************************************/

  #define fsetord FC_FUNC(setord,SETORD)
    void fsetord(int*);
  #define fgetord FC_FUNC(getord,GETORD)
    void fgetord(int*);
  #define fsetalf FC_FUNC(setalf,SETALF)
    void fsetalf(double*, double*);
  #define fgetalf FC_FUNC(getalf,GETALF)
    void fgetalf(double*, double*);
  #define fsetcbt FC_FUNC(setcbt,SETCBT)
    void fsetcbt(int*, int*, int*, int*);
  #define fmixfns FC_FUNC(mixfns,MIXFNS)
    void fmixfns(int*, double*, double*, double*);
  #define fgetcbt FC_FUNC(getcbt,GETCBT)
    void fgetcbt(int*, double*, double*, double*);
  #define fsetabr FC_FUNC(setabr,SETABR)
    void fsetabr(double*, double*);
  #define fgetabr FC_FUNC(getabr,GETABR)
    void fgetabr(double*, double*);
  #define fnfrmiq FC_FUNC(nfrmiq,NFRMIQ)
    int fnfrmiq(int*, int*, int*);
  #define fnflavs FC_FUNC(nflavs,NFLAVS)
    int fnflavs(int*, int*);
  #define fcpypar FC_FUNC(cpypar,CPYPAR)
    void fcpypar(double*, int*, int*);
  #define fusepar FC_FUNC(usepar,USEPAR)
    void fusepar(int*);
  #define fkeypar FC_FUNC(keypar,KEYPAR)
    int fkeypar(int*);
  #define fkeygrp FC_FUNC(keygrp,KEYGRP)
    int fkeygrp(int*, int*);
  #define fpushcp FC_FUNC(pushcp,PUSHCP)
    void fpushcp();
  #define fpullcp FC_FUNC(pullcp,PULLCP)
    void fpullcp();

  /**************************************************************/
  /*  QCDNUM pdf output routines from usrpdf.f                  */
  /**************************************************************/

  #define fallfxq FC_FUNC(allfxq,ALLFXQ)
    void fallfxq(int*, double*, double*, double*, int*, int*);
  #define fallfij FC_FUNC(allfij,ALLFIJ)
    void fallfij(int*, int*, int*, double*, int*, int*);
  #define fbvalxq FC_FUNC(bvalxq,BVALXQ)
    double fbvalxq(int*, int*, double*, double*, int*);
  #define fbvalij FC_FUNC(bvalij,BVALIJ)
    double fbvalij(int*, int*, int*, int*, int*);
  #define ffvalxq FC_FUNC(fvalxq,FVALXQ)
    double ffvalxq(int*, int*, double*, double*, int*);
  #define ffvalij FC_FUNC(fvalij,FVALIJ)
    double ffvalij(int*, int*, int*, int*, int*);
  #define fsumfxq FC_FUNC(sumfxq,SUMFXQ)
    double fsumfxq(int*, double*, int*, double*, double*, int*);
  #define fsumfij FC_FUNC(sumfij,SUMFIJ)
    double fsumfij(int*, double*, int*, int*, int*, int*);
  #define ffsplne FC_FUNC(fsplne,FSPLNE)
    double ffsplne(int*, int*, double*, int*);
  #define fsplchk FC_FUNC(splchk,SPLCHK)
    double fsplchk(int*, int*, int*);
  #define ffflist FC_FUNC(fflist,FFLIST)
    void ffflist(int*, double*, int*, double*, double*, double*, int*, int*);
  #define fftable FC_FUNC(ftable,FTABLE)
    void fftable(int*, double*, int*, double*, int*, double*, int*, double*, int*);
  #define fffplotcpp FC_FUNC(ffplotcpp,FFPLOTCPP)
    void fffplotcpp(char*, int*, double (*)(int*, double*, bool*), int*, double*,  double*, int*, char*, int*);

  /**************************************************************/
  /*  QCDNUM weight routines from usrwgt.f                      */
  /**************************************************************/

  #define ffillwt FC_FUNC(fillwt,FILLWT)
    void ffillwt(int*, int*, int*, int*);
  #define fdmpwgtcpp FC_FUNC(dmpwgtcpp,DMPWGTCPP)
    void fdmpwgtcpp(int*, int*, char*, int*);
  #define freadwtcpp FC_FUNC(readwtcpp,READWTCPP)
    void freadwtcpp(int*, char*, int*, int*, int*, int*, int*);
  #define fwtfilecpp FC_FUNC(wtfilecpp,WTFILECPP)
    void fwtfilecpp(int*, char*, int*);
  #define fnwused FC_FUNC(nwused,NWUSED)
    void fnwused(int*, int*, int*);

  /**************************************************************/
  /*  HQSTF routines                                            */
  /**************************************************************/

  #define fhqwords FC_FUNC(hqwords,HQWORDS)
    void fhqwords(int*, int*);
  #define fhqparms FC_FUNC(hqparms,HQPARMS)
    void fhqparms(double*, double*, double*);
  #define fhqqfrmu FC_FUNC(hqqfrmu,HQQFRMU)
    double fhqqfrmu(double*);
  #define fhqmufrq FC_FUNC(hqmufrq,HQMUFRQ)
    double fhqmufrq(double*);
  #define fhswitch FC_FUNC(hswitch,HSWITCH)
    void fhswitch(int*);
  #define fhqstfun FC_FUNC(hqstfun,HQSTFUN)
    void fhqstfun(int*, int*, double*, double*, double*, double*, int*, int*);
  #define fhqfillw FC_FUNC(hqfillw,HQFILLW)
    void fhqfillw(int*, double*, double*, double*, int*);
  #define fhqdumpwcpp FC_FUNC(hqdumpwcpp,HQDUMPWCPP)
    void fhqdumpwcpp(int*, char*, int*);
  #define fhqreadwcpp FC_FUNC(hqreadwcpp,HQREADWCPP)
    void fhqreadwcpp(int*, char*, int*, int*, int*);

  /**************************************************************/
  /*  ZMSTF routines                                            */
  /**************************************************************/

  #define fzmwords FC_FUNC(zmwords,ZMWORDS)
    void fzmwords(int*, int*);
  #define fzmdefq2 FC_FUNC(zmdefq2,ZMDEFQ2)
    void fzmdefq2(double*, double*);
  #define fzmabval FC_FUNC(zmabval,ZMABVAL)
    void fzmabval(double*, double*);
  #define fzmqfrmu FC_FUNC(zmqfrmu,ZMQFRMU)
    double fzmqfrmu(double*);
  #define fzmufrmq FC_FUNC(zmufrmq,ZMUFRMQ)
    double fzmufrmq(double*);
  #define fzswitch FC_FUNC(zswitch,ZSWITCH)
    void fzswitch(int*);
  #define fzmstfun FC_FUNC(zmstfun,ZMSTFUN)
    void fzmstfun(int*, double*, double*, double*, double*, int*, int*);
  #define fzmfillw FC_FUNC(zmfillw,ZMFILLW)
    void fzmfillw(int*);
  #define fzmdumpwcpp FC_FUNC(zmdumpwcpp,ZMDUMPWCPP)
    void fzmdumpwcpp(int*, char*, int*);
  #define fzmreadwcpp FC_FUNC(zmreadwcpp,ZMREADWCPP)
    void fzmreadwcpp(int*, char*, int*, int*, int*);
}

#endif

